#ifndef	MAINWINDOW_HPP
#define	MAINWINDOW_HPP

// $VER: MainWindow.hpp 39.4 (09.11.97)
//
//
// (C) Copyright 1996,97 Markus Hillenbrand
//     All Rights Reserved, No Warranty

#include "GUIC_Window.hpp"
#include "GUIC_FileRequester.hpp"

class GUIC_ApplicationC;
class GUIC_EventC;
class GUIC_ImageButtonC;
class GUIC_PanelC;
class GUIC_ScreenC;

#include "HTMLWindow.hpp"
#include "PrefsWindow.hpp"
#include "ManagerWindow.hpp"
#include "CompareWindow.hpp"

class MainWindowC : public GUIC_WindowC
	{
	public:
		MainWindowC 			(GUIC_ApplicationC &app, GUIC_ScreenC &screen, PrefsWindowC &pWindow, HTMLWindowC &hWindow, ManagerWindowC &mWindow, CompareWindowC &compareWindow);
		~MainWindowC 			(VOID);
		
		STRPTR	getClass		(VOID);
		BOOL 	action 		(GUIC_EventC &event);
		
	protected:
		VOID 		cleanUp		(VOID);
		
	private:
		BOOL		load			(STRPTR file);
		BOOL		save			(STRPTR file);
		
		GUIC_ApplicationC 		*app;
		GUIC_ScreenC 			*screen;
		GUIC_FileRequesterC	fileRequester;
		
		HTMLWindowC			*hWindow;
		PrefsWindowC			*pWindow;
		ManagerWindowC		*mWindow;
		CompareWindowC		*cWindow;
		
		GUIC_PanelC				*panel;
		GUIC_ImageButtonC	*loadButton, *saveButton, *button1, *button2, *button3, *button4, *button5, *button6;
	};

#endif

